# API Documentation

Version: 1.183

## Servers

Sandbox
```
https://api-developer-sandbox.zocdoc.com
```

Production
```
https://api-developer.zocdoc.com
```

## Security

### ClientCredentialsFlow

Machine to machine authentication (for use from client server to Zocdoc).
Production: `https://auth.zocdoc.com/oauth/token`
Sandbox: `https://auth-api-developer-sandbox.zocdoc.com/oauth/token`

Type: oauth2
Token URL: https://auth.zocdoc.com/oauth/token
Scopes:
- `external.credential.rotate`: Rotate the authenticated client secret.
- `external.appointment.write`: Book and modify appointments.
- `external.appointment.read`: Read basic details of your appointments.
- `external.anonymous_token.write`: Create anonymous tokens used for discovery endpoints.
- `external.provider_insurance.write`: Update the insurance accepted by a provider.
- `external.schedulable_entity.read`: Read schedulable entities.
- `external.booking_intent.write`: Create and modify booking intents.
- `external.booking_intent.read`: Read booking intents.
- `external.provider.read`: Read provider details.
- `external.partner_consent.read`: Read your partner-connect consent grants.
- `external.partner_consent.write`: Revoke your partner-connect consent grants.
- `external.appointment_consent.read`: Read patient booking consents for an appointment.
- `external.appointment_payment.read`: Read the patient payment method for an appointment.

### AuthorizationCodeFlow

Log in as a user. Client Secret is not necessary for this login flow.
Production: `https://auth.zocdoc.com`
Sandbox: `https://auth-api-developer-sandbox.zocdoc.com`

Type: oauth2
Authorization URL: https://auth.zocdoc.com/authorize
Token URL: https://auth.zocdoc.com/oauth/token
Scopes:
- `external.appointment.write`: Book and modify appointments.
- `external.appointment.read`: Read basic details of your appointments.
- `external.schedulable_entity.read`: Read schedulable entities.

## Download OpenAPI description

 - [API Documentation](https://api-docs.zocdoc.com/_bundle/apis/index.yaml)

## NPIs

 - [GET /v1/reference/npi](https://api-docs.zocdoc.com/apis/reference/getprovidernpis.md): Retrieves the list of active provider NPIs within the developer's Zocdoc directory. The NPIs retrieved here can be used to search for providers in the /v1/providers endpoint to facilitate availability
## Directory Management

 - [GET /v1/schedulable_entities](https://api-docs.zocdoc.com/apis/schedulable-entities/getschedulableentities.md): Get the list of schedulable entities within the developer's Zocdoc directory (provider-locations, etc.) with availability information. NPIs can be used to search for providers in the /v1/providers end
 - [PUT /v1/schedulable_entities/overlaps](https://api-docs.zocdoc.com/apis/schedulable-entities/putschedulableentitiesoverlaps.md): Submit NPI overlaps to compare your provider directory with providers bookable on Zocdoc. Send real-time distribution status (`developer_app_state`), unverified addresses and other data required for j
## Insurance

 - [GET /v1/insurance_plans](https://api-docs.zocdoc.com/apis/insurance-reference/getinsuranceplans.md): Get insurance plans
 - [GET /v1/insurance_plans/{insurance_plan_id}](https://api-docs.zocdoc.com/apis/insurance-reference/getinsuranceplan.md): Get insurance plan by id.
## Providers

 - [GET /v1/providers](https://api-docs.zocdoc.com/apis/providers/getproviders.md): Retrieves specific providers within the developer's directory by NPI search. This endpoint searches active providers that are listed on Zocdoc. It returns the provider's information (such as name, gen
## Provider locations

 - [GET /v1/provider_locations](https://api-docs.zocdoc.com/apis/provider-locations/getproviderlocations.md): This endpoint accepts parameters such as zip code, specialty, visit reason and accepted insurance to return a filtered set of providers within the developer's directory. The response includes addition
 - [GET /v1/provider_locations/{provider_location_id}](https://api-docs.zocdoc.com/apis/provider-locations/getproviderlocation.md): Get info about a provider location by provider_location_id
 - [GET /v1/provider_locations/availability](https://api-docs.zocdoc.com/apis/provider-locations/getproviderlocationsavailability.md): Retrieves availability for a set of provider locations. Required parameters passed include provider location ids, visit reason id and patient type. Visit reason and patient type (new or existing) are
 - [GET /v1/provider_locations/{provider_location_id}/insurance_mappings](https://api-docs.zocdoc.com/apis/provider-locations/getproviderlocationinsurancemappings.md): Get eligible insurance plans and insurance mappings for a provider location by provider_location_id
 - [POST /v1/provider_locations/{provider_location_id}/insurance_mappings](https://api-docs.zocdoc.com/apis/provider-locations/updateproviderlocationinsurancemappings.md): Submits a request to update mapped insurance plans. This is an asynchronous operation and the response indicates the request was accepted for processing, not that the update is complete.
## Reviews

 - [GET /v1/providers/{provider_id}/reviews](https://api-docs.zocdoc.com/apis/reviews/getproviderreviews.md): Get a provider's review count and average ratings by their Zocdoc provider ID. Returns numeric values only: `total_reviews`, and average overall, bedside, and wait time ratings on a 1-5 scale rounded
 - [GET /v1/providers/reviews](https://api-docs.zocdoc.com/apis/reviews/getproviderreviewsbatch.md): Get review counts and average ratings for up to 100 providers in a single call, by their Zocdoc provider IDs. Returns numeric values only: `total_reviews`, and average overall, bedside, and wait time
## Facilities

 - [GET /v1-beta/facilities](https://api-docs.zocdoc.com/apis/facilities/getfacilities.md): Get a set of facilities within the developer's network.
 - [GET /v1-beta/facilities/{facility_id}](https://api-docs.zocdoc.com/apis/facilities/getfacility.md): Get facility by facility id.
## Calendar integration timeslots

 - [GET /v1/providers/{provider_id}/calendar/timeslots](https://api-docs.zocdoc.com/apis/calendar-integration-timeslots/getprovidercalendartimeslots.md): Get timeslots for a provider and date.
 - [PUT /v1/providers/{provider_id}/calendar/timeslots](https://api-docs.zocdoc.com/apis/calendar-integration-timeslots/putprovidercalendartimeslots.md): This endpoint sets the complete list of available slots for a specific provider on a specific date. Each request must include the entire set of slots for that date. If a provider wishes to list times
## Appointments

 - [POST /v1/appointments](https://api-docs.zocdoc.com/apis/appointments/createappointment.md): This endpoint is used for creating new appointments. Developers should gather the necessary information to pass in the request body as inputs for this endpoint. Only timeslots retrieved from the /v1/p
 - [GET /v1/appointments](https://api-docs.zocdoc.com/apis/appointments/getappointments.md): This endpoint retrieves the paginated list of appointment details and statuses for the given credential. By default, appointments will be returned in descending order of start time. A maximum of 1,00
 - [GET /v1/appointments/{appointment_id}](https://api-docs.zocdoc.com/apis/appointments/getappointment.md): This endpoint retrieves updated appointment details and the status of a single existing appointment. Developers must send a valid `appointment_id` as input in the request body, and Zocdoc returns the
 - [GET /v1/appointments/{appointment_id}/participants](https://api-docs.zocdoc.com/apis/appointments/getappointmentparticipants.md): This endpoint retrieves the participants of an appointment. Developers must provide a valid `appointment_id` as a path parameter, and Zocdoc returns the participants of that appointment.
 - [POST /v1/appointments/cancel](https://api-docs.zocdoc.com/apis/appointments/cancelappointment.md): This endpoint is used to request the cancellation of an appointment in a non-cancelled status. (Non-cancelled statuses include: pending_booking, booking_failed, confirmed, pending_reschedule, reschedu
 - [POST /v1/appointments/confirm](https://api-docs.zocdoc.com/apis/appointments/confirmappointment.md): This endpoint is used to confirm an appointment in pending booking status. Developers must send a valid `appointment_id` as input in the request body.
 - [POST /v1/appointments/reschedule](https://api-docs.zocdoc.com/apis/appointments/rescheduleappointment.md): This endpoint is used to only modify the appointment time and request the reschedule of an appointment in pending_booking, confirmed, pending_reschedule, or rescheduled status. Developers must send a
 - [POST /v1/appointments/{appointment_id}/attachments](https://api-docs.zocdoc.com/apis/appointments/uploadappointmentattachment.md): This endpoint is used to upload attachment documents related to the appointment for the provider to view. You can upload more than one attachment with the same attachment_type for the same appointment
 - [PUT /v1/appointments/update-status](https://api-docs.zocdoc.com/apis/appointments/updateappointmentstatus.md): Use this endpoint to update the status of an appointment to either 'arrived' or 'no_show'. - `arrived` : Indicates the patient has arrived at the office. - `no_show` : Indicates the patient did not sh
## Webhook

 - [POST /v1/webhook/mock-request](https://api-docs.zocdoc.com/apis/webhook/mockwebhookrequest.md)
 - [POST /v1/webhook/insurance-ref-data/mock-request](https://api-docs.zocdoc.com/apis/webhook/sendinsurancerefdatamockrequest.md): **Sandbox only.** Sends one signed sample insurance reference-data notification to the `webhook_url` you supply, signed with the `webhook_key` you supply, and returns the notification it sent. Verify
 - [POST insurance_plans_updated](https://api-docs.zocdoc.com/apis/webhook/insuranceplansupdated.md): Zocdoc sends this to your registered insurance reference-data webhook URL when one or more insurance plans change. Refetch the named plans from [`GET /v1/insurance_plans`](/apis#operation/getInsurance
 - [POST insurance_carriers_updated](https://api-docs.zocdoc.com/apis/webhook/insurancecarriersupdated.md): Zocdoc sends this to your registered insurance reference-data webhook URL when one or more insurance carriers change. Carriers are returned on the `carrier` object of each plan, so refetch the affecte
## Specialties

 - [GET /v1/specialties](https://api-docs.zocdoc.com/apis/specialties/getspecialties.md): Get specialties with optional filtering by care category
 - [GET /v1/specialties/{specialty_id}](https://api-docs.zocdoc.com/apis/specialties/getspecialtybyid.md): Get specialty by id
## Visit Reasons

 - [GET /v1/visit_reasons](https://api-docs.zocdoc.com/apis/visit-reasons/getvisitreasons.md): Get visit reasons with optional filtering by specialty
 - [GET /v1/visit_reasons/{visit_reason_id}](https://api-docs.zocdoc.com/apis/visit-reasons/getvisitreasonbyid.md): Get visit reason by id
